diff --git a/lib/librte_ethdev/rte_ethdev.c b/lib/librte_ethdev/rte_ethdev.c
index 17ddacc78ded..332d7a789380 100644
--- a/lib/librte_ethdev/rte_ethdev.c
+++ b/lib/librte_ethdev/rte_ethdev.c
@@ -3948,28 +3948,28 @@ rte_eth_fec_get_capability(uint16_t port_id,
 }
 
 int
-rte_eth_fec_get(uint16_t port_id, uint32_t *fec_capa)
+rte_eth_fec_get(uint16_t port_id, uint32_t *fec_mode)
 {
 	struct rte_eth_dev *dev;
 
-	if (fec_capa == NULL)
+	if (fec_mode == NULL)
 		return -EINVAL;
 
 	RTE_ETH_VALID_PORTID_OR_ERR_RET(port_id, -ENODEV);
 	dev = &rte_eth_devices[port_id];
 	RTE_FUNC_PTR_OR_ERR_RET(*dev->dev_ops->fec_get, -ENOTSUP);
-	return eth_err(port_id, (*dev->dev_ops->fec_get)(dev, fec_capa));
+	return eth_err(port_id, (*dev->dev_ops->fec_get)(dev, fec_mode));
 }
 
 int
-rte_eth_fec_set(uint16_t port_id, uint32_t fec_capa)
+rte_eth_fec_set(uint16_t port_id, uint32_t fec_mode)
 {
 	struct rte_eth_dev *dev;
 
 	RTE_ETH_VALID_PORTID_OR_ERR_RET(port_id, -ENODEV);
 	dev = &rte_eth_devices[port_id];
 	RTE_FUNC_PTR_OR_ERR_RET(*dev->dev_ops->fec_set, -ENOTSUP);
-	return eth_err(port_id, (*dev->dev_ops->fec_set)(dev, fec_capa));
+	return eth_err(port_id, (*dev->dev_ops->fec_set)(dev, fec_mode));
 }
 
 /*
diff --git a/lib/librte_ethdev/rte_ethdev.h b/lib/librte_ethdev/rte_ethdev.h
index 2cbce958cf6c..0aefb7cb2f4a 100644
--- a/lib/librte_ethdev/rte_ethdev.h
+++ b/lib/librte_ethdev/rte_ethdev.h
@@ -3699,7 +3699,7 @@ int rte_eth_fec_get_capability(uint16_t port_id,
  *
  * @param port_id
  *   The port identifier of the Ethernet device.
- * @param fec_capa
+ * @param fec_mode
  *   A bitmask of enabled FEC modes. If AUTO bit is set, other
  *   bits specify FEC modes which may be negotiated. If AUTO
  *   bit is clear, specify FEC modes to be used (only one valid
@@ -3712,7 +3712,7 @@ int rte_eth_fec_get_capability(uint16_t port_id,
  *   - (-ENODEV)  if *port_id* invalid.
  */
 __rte_experimental
-int rte_eth_fec_get(uint16_t port_id, uint32_t *fec_capa);
+int rte_eth_fec_get(uint16_t port_id, uint32_t *fec_mode);
 
 /**
  * @warning
@@ -3722,7 +3722,7 @@ int rte_eth_fec_get(uint16_t port_id, uint32_t *fec_capa);
  *
  * @param port_id
  *   The port identifier of the Ethernet device.
- * @param fec_capa
+ * @param fec_mode
  *   A bitmask of allowed FEC modes. If AUTO bit is set, other
  *   bits specify FEC modes which may be negotiated. If AUTO
  *   bit is clear, specify FEC modes to be used (only one valid
@@ -3735,7 +3735,7 @@ int rte_eth_fec_get(uint16_t port_id, uint32_t *fec_capa);
  *   - (-ENODEV)  if *port_id* invalid.
  */
 __rte_experimental
-int rte_eth_fec_set(uint16_t port_id, uint32_t fec_capa);
+int rte_eth_fec_set(uint16_t port_id, uint32_t fec_mode);
 
 /**
  * Get current status of the Ethernet link flow control for Ethernet device
diff --git a/lib/librte_ethdev/rte_ethdev_driver.h b/lib/librte_ethdev/rte_ethdev_driver.h
index 0eacfd842581..616a14d0361e 100644
--- a/lib/librte_ethdev/rte_ethdev_driver.h
+++ b/lib/librte_ethdev/rte_ethdev_driver.h
@@ -625,7 +625,7 @@ typedef int (*eth_fec_get_capability_t)(struct rte_eth_dev *dev,
  *
  * @param dev
  *   ethdev handle of port.
- * @param fec_capa
+ * @param fec_mode
  *   a bitmask of enabled FEC modes. If AUTO bit is set, other
  *   bits specify FEC modes which may be negotiated. If AUTO
  *   bit is clear, specify FEC modes to be used (only one valid
@@ -642,7 +642,7 @@ typedef int (*eth_fec_get_capability_t)(struct rte_eth_dev *dev,
  *   Device is removed.
  */
 typedef int (*eth_fec_get_t)(struct rte_eth_dev *dev,
-			     uint32_t *fec_capa);
+			     uint32_t *fec_mode);
 
 /**
  * @internal
@@ -650,7 +650,7 @@ typedef int (*eth_fec_get_t)(struct rte_eth_dev *dev,
  *
  * @param dev
  *   ethdev handle of port.
- * @param fec_capa
+ * @param fec_mode
  *   bitmask of allowed FEC modes. It must be only one
  *   if AUTO is disabled. If AUTO is enabled, other
  *   bits specify FEC modes which may be negotiated.
@@ -667,7 +667,7 @@ typedef int (*eth_fec_get_t)(struct rte_eth_dev *dev,
  * @retval -EIO
  *   Device is removed.
  */
-typedef int (*eth_fec_set_t)(struct rte_eth_dev *dev, uint32_t fec_capa);
+typedef int (*eth_fec_set_t)(struct rte_eth_dev *dev, uint32_t fec_mode);
 
 /**
  * @internal